      SUBROUTINE  DFPMIN(P, N, FTOL,ITER, FRET,IOU)
C ROUTINE FROM NUMERICAL RECIPES BOOK PAGE 310
C BROYDEN-FLETCHER-GOLDFARB-SHANNO VERSION OF THE DAVIDON-FLETCHER-POWELL
C ALGORITHM.
C P IS STARTING POINT VECTOR OF LENGTH N(INPUT)
C N IS DIMENSIONALITY OF P (INPUT)
C FTOL IS CONVERGENCE CRITERION TO BE SUPPLIED (INPUT)
C ITER IS NUMBER OF ITERATIONS PERFORMED(OUTPUT)
C FRET IS MINIMUM VALUE OF THE FUNCTION
C USES ROUTINES: FUNC,DFUNC,LINMIN


      PARAMETER  (NMAX=2,ITMAX=200, EPS=1.E-10)
      DIMENSION  P(N),HESSIN(NMAX,NMAX), XI(NMAX), G(NMAX),
     &           DG(NMAX), HDG(NMAX)
C      WRITE(*,6000) P(1),P(2),N,FTOL
C 6000 FORMAT(' 6000  ',2F6.4,I4,F10.4)
      ITSFLG=1
      CALL DFUNC(FRET,P,G,ITSFLG)
      ITSFLG=2
      FP=FRET
      WRITE(IOU,6010) FP
 6010 FORMAT(' FUNCTION AT INITIAL VALUES = ',F12.6//)
C      WRITE(*,6020) N,P(1),P(2),G(1),G(2)
C 6020 FORMAT(' 6020 ',I4,4F12.6)
C 
      DO 12 I=1,N 
          DO 11 J=1,N 
              HESSIN(I,J)=0. 
  11           CONTINUE 
          HESSIN(I,I)=1. 
          XI(I)=-G(I) 
  12       CONTINUE 
      DO 24 ITER=1,ITMAX
      WRITE(*,50) ITER
  50  FORMAT(' ITERATION = ',I4)
	  CALL LINMIN(P, XI, N, FRET)
C      WRITE(*,6030) P(1),P(2),XI(1),XI(2),FRET
C 6030 FORMAT(' 6030 ',5F12.6)
	  IF(2.*ABS(FRET-FP).LE.FTOL*(ABS(FRET)+ABS(FP)+EPS))RETURN
	  FP=FRET
          DO 13 I=1,N 
              DG(I)=G(I) 
  13           CONTINUE 
	  CALL DFUNC(FRET,P,G,ITSFLG)
          DO 14 I=1,N 
              DG(I)=G(I)-DG(I) 
  14           CONTINUE 
          DO 16 I=1,N 
              HDG(I)=0. 
              DO 15 J=1,N 
                  HDG(I)=HDG(I)+HESSIN(I,J)*DG(J) 
  15               CONTINUE 
  16           CONTINUE 
          FAC=0. 
          FAE=0. 
          DO 17 I=1,N 
              FAC=FAC+DG(I)*XI(I) 
              FAE=FAE+DG(I)*HDG(I) 
  17           CONTINUE 
          FAC=1./FAC 
          FAD=1./FAE 
          DO 18 I=1,N 
              DG(I)=FAC*XI(I)-FAD*HDG(I) 
  18           CONTINUE 
          DO 21 I=1,N 
              DO 19 J=1,N 
                  HESSIN(I,J)=HESSIN(I,J)+FAC*XI(I)*XI(J) 
     &             -FAD*HDG(I)*HDG(J)+FAE*DG(I)*DG(J) 
  19               CONTINUE 
  21           CONTINUE 
          DO 23 I=1,N 
              XI(I)=0. 
              DO 22 J=1,N 
                  XI(I)=XI(I)-HESSIN(I,J)*G(I) 
  22               CONTINUE 
  23           CONTINUE 
  24       CONTINUE 
      PAUSE 'too many iterations in DFPMIN' 
      RETURN 
      END 

