C  METRIC.FOR: COMMON METRIC IN IRT,USING CHI-SQUARED METHOD.
C  BY D. R. DIVGI, CENTER FOR NAVAL ANALYSES, BOX 16268, ALEXANDRIA VA 22302
C  REF: APPLED PSYCH MEASUREMENT, 1985, V. 9, 413-415
C
C  SECOND CALIBRATION IS TRANSFORMED TO METRIC OF FIRST. NOTATION AS IN
C  STOCKING & LORD (AMP 83). INFORMATION MATRICES ARE COMPUTED FROM LINEAR
C  EQN, AA IS FITTED BY QUADRATIC INTERPOLATION. INITIAL ESTIMATE IS BASED
C  ON WEIGHT MEANS OF A'S. TO PROTECT AGAINST DIVERGENCE, PROGRAM IS
C  INTERACTIVE AND WRITES INTERMEDIATE RESULTS. USER DECIDES WHEN CONVERGENCE
C  HAS BEEN ACHIEVED.
C ***FACTOR 1.7 IS ASSUMED TO HAVE MULTIPLIED A'S ALREADY, SO DOES NOT APPEAR.
C      REVISED 3/11/87  modified for PC by gary j. lautenschlager 7/30/87
C
      CHARACTER TITLE*80,FILEN*14
      INTEGER NT,NT1,NTHALF,IT,NI,ICAL,I
      REAL STEP,CDF,TLIST(100),SAMSIZ(2),DELTA,A(2,50),B(2,50),C(2,50),
     2 AA0,BB,Q0,AA1,Q1,AA2,Q2,D1,D2,BETA,ALPHA,AA,Q,RESPON,WT
      COMMON  /AREA1/NT,SAMSIZ,TLIST,WT     /AREA2/NI,A,B,C
C 
      WRITE (*,7)
    7 FORMAT(/////,' ENTER  1  TO USE WEIGHTED MEANS APPROACH: ',\)
      READ(*,*) WT
      WRITE (*,10)
   10 FORMAT(17H ENTER FILENAME: ,\)
      READ(*,14) FILEN
   14 FORMAT(A14)
C
        OPEN(5,FILE=FILEN,STATUS='OLD')   
C***** COMPUTE THETAS FOR INFORMATION MATRICES
      NT=50
      NT1=NT+1
      NTHALF=NT1/2
      STEP=1./NT
      CDF=-STEP/2.
      DO 20 IT=1,NTHALF
      CDF=CDF+STEP
      CALL ZSCORE(CDF,TLIST(IT))
      TLIST(NT1-IT)=-TLIST(IT)
20    CONTINUE
C*****    READ THE TWO SETS OF ESTIMATES
      READ(5,890) TITLE
890   FORMAT(A80)
      WRITE (*,895) TITLE
895   FORMAT(//A81)
      READ(5,*) NI,SAMSIZ,DELTA
      DO 40 ICAL=1,2
      WRITE (*,900) ICAL
900   FORMAT(/' CALIBRATION',I2,': A"S, B"S AND C"S ARE')
      READ(5,*)  (A(ICAL,I),I=1,NI)
      WRITE (*,910) (A(ICAL,I),I=1,NI)
910   FORMAT(10(/10F8.2))
      READ(5,*)  (B(ICAL,I),I=1,NI)
      WRITE (*,910) (B(ICAL,I),I=1,NI)
      READ(5,*)  (C(ICAL,I),I=1,NI)
      WRITE (*,910) (C(ICAL,I),I=1,NI)
40    CONTINUE
C
        CLOSE(5)
C
      WRITE (*,930)
930   FORMAT(/' PROGRAM PRINTS TWO LINES AFTER EACH ITERATION.'
     2/' FIRST LINE CONTAINS 3 CURRENT AND NEXT VALUE OF ',
     3'AA, NEXT VALUE OF BB.'/' SECOND CONTAINS 4 CORRESPONDING Q"S,',
     4' I.E. VALUES OF FUNCTION BEING MINIMIZED')
C*****    COMPUTE COVARIANCE MATRICES.VARIABLES ARE PASSED THRU COMMON AREA
C*****    SUBROUTINE RETURNS INITIAL ESTIMATE OF AA = RATIO OF MEAN A'S
      CALL COVAR(AA0)
C*****    AT FIRST USE TWO POINTS ABOUT INITIAL, AT DISTANCE DELTA
C*****    POINT O IS IN MIDDLE, 1 IS ON LEFT, 2 ON RIGHT
      CALL SUMCSQ(AA0,BB,Q0)
60    AA1=AA0-DELTA
      CALL SUMCSQ(AA1,BB,Q1)
      AA2=AA0+DELTA
      CALL SUMCSQ(AA2,BB,Q2)
C*****    USE QUADRATIC INTERPOLATION TO FIND ESTIMATE AA
80    D1=AA1-AA0
      D2=AA2-AA0
C*****    ALPHA BETA ARE LINEAR QUADRATIC COEFFICIENT
      BETA=(D2*(Q1-Q0)-D1*(Q2-Q0))/D1/D2/(D1-D2)
      ALPHA=(Q1-Q0-BETA*D1*D1)/D1
      AA=AA0-ALPHA/2./BETA
      CALL SUMCSQ(AA,BB,Q)
      WRITE (*,940) AA1,AA0,AA2,AA,BB,Q1,Q0,Q2,Q
940   FORMAT(/4F17.4,F10.4/4E17.6)
      IF(AA.LE.AA1.OR.AA.GE.AA2) WRITE (*,945)
945   FORMAT(' WARNING:  NEW ESTIMATE LIES OUTSIDE CURRENT RANGE')
C*****    USER CHOOSES: STOP, CONTINUE, OR RESTART WITH NEW ESTIMATE
      WRITE (*,950)
950   FORMAT(/' ENTER  <0 TO STOP, 0 TO CONTINUE, >0 = VALUE OF NEW',
     2 ' ESTIMATE.')
      READ (*,*) RESPON 
      IF (RESPON.LT.0.) GO TO 9999
      IF (RESPON.EQ.0.) GO TO 100
C*****           RESTART WITH USER'S VALUE AS INITIAL ESTIMATE
      AA0=RESPON
      Q0=Q
      CALL  SUMCSQ(AA0,BB,Q0)
      GO TO 60
C*****  CONTINUE ITERATION. PROGRAM ASSUMES THE NEW ESTIMATE LIES INSIDE THE
C*****  PREVIOUS RANGE FROM AA1 TO AA2.
100   IF(AA.GT.AA0) GO TO 120
      AA2=AA0
      Q2=Q0
      GO TO 140
120   AA1=AA0
      Q1=Q0
140   AA0=AA
      Q0=Q
      GO TO 80
C
9999  WRITE (*,1000)
1000  FORMAT(//' *************************************************')
      STOP
      END
C****************************************************************************
      SUBROUTINE COVAR(AA)
C     COMPUTE COVARIANCE MATRICES OF SAMPLING ERRORS. ITEM PARAMETERS AND
C     MATRICES ARE IN COMMON AREAS. THE ROUTINE ALSO RETURNS INITIAL ESTIMATE
C     OF AA, WHICH IS THE RATIO OF WEIGHTED MEANS OF A'S.
C     FORMULAS FOR COVARIANCE MATRIX ARE FROM LORD'S BOOK, P. 191
C
      INTEGER  ICAL,I,NI,NT,IT
      REAL  AA,SUMWT,SUMA,FACTOR,SAMSIZ(2),AI,BI,CI,C1,A(2,50),B(2,50),
     2 C(2,50),INFO1,INFO2,INFO3,TLIST(100),DIFF,PSI,P,RATIO,ADD,
     3 DETMIN,COV(2,50,3),WEIGHT
      COMMON /AREA1/NT,SAMSIZ,TLIST,WT  /AREA2/NI,A,B,C  /AREA3/COV
C
      DO 120 ICAL=1,2
      SUMWT=0.
      SUMA=0.
      FACTOR=SAMSIZ(ICAL)/NT
C
      DO 100 I=1,NI
      AI=A(ICAL,I)
      BI=B(ICAL,I)
      CI=C(ICAL,I)
      C1=1.-CI
      INFO1=0.
      INFO2=0.
      INFO3=0.
C*****   SUM OVER ABILITIES TO GET COVARIANCE MATRIX FOR THIS ITEM
      DO 80 IT=1,NT
      DIFF=BI-TLIST(IT)
      PSI=1./(1.+EXP(AI*DIFF))
      P=CI+C1*PSI
      RATIO=(1.-P)/P
      ADD=PSI*PSI*RATIO
      INFO2=INFO2+ADD
      ADD=ADD*DIFF
      INFO3=INFO3+ADD
      INFO1=INFO1+ADD*DIFF
80    CONTINUE
C*****   END OF SUM OVER ABILITIES
      INFO1=INFO1*FACTOR
      INFO2=INFO2*AI*AI*FACTOR
      INFO3=INFO3*AI*FACTOR
      DETMIN=INFO1*INFO2-INFO3*INFO3
      COV(ICAL,I,1)=INFO2/DETMIN
      COV(ICAL,I,2)=INFO1/DETMIN
      COV(ICAL,I,3)=-INFO3/DETMIN
C*****   MEANS ARE NEEDED FOR INITIAL ESTIMATE OF AA
C*****   WEIGHTED MEANS CAN BE USED IF PREFERRED. WEIGHT=RECIPROCAL OF VARIANCE
      IF(WT.GT.0.) GO TO 85
      WEIGHT=1.
      GO TO 95
 85   continue
      WEIGHT=DETMIN/INFO2	 
 95   continue
      SUMWT=SUMWT+WEIGHT
      SUMA=SUMA+WEIGHT*AI
100   CONTINUE
C*****    END OF LOOP OVER ITEMS
      IF(ICAL.EQ.1) AA=SUMA/SUMWT
      IF(ICAL.EQ.2) AA=SUMA/SUMWT/AA
120   CONTINUE
C
      RETURN
      END
C*****************************************************************************
      SUBROUTINE SUMCSQ(AA,BB,Q)
C     COMPUTE SUM OF CHI-SQUARES, ALSO RETURN VALUE OF BB OBTAINED FROM LINEAR
C     EQUATION.  FOR SECOND CALIBRATION, (AA) ELEMENT GETS DIVIDED AND (BB)
C     ELEMENT GETS MULTIPLIED BY AA*2. ADD THIS TRANSFORMED MATRIX TO THAT FOR
C     FIRST CALIBRATION, INVERT. COMPUTE BB FIRST, THEN Q = SUM OF CHI-SQUARES.
C
      INTEGER  I,NI
      REAL  AA,BB,Q,COV1,COV2,COV3,DETMIN,COV(2,50,3),INV(50,3),DENOM,
     2 A(2,50),B(2,50),C(2,50),DIFFA,DIFFB
      COMMON /AREA2/NI,A,B,C  /AREA3/COV
C
C*****    TRANSFORM SECOND MATRIX,  ADD TO FIRST, INVERT STORE
      DO 20 I=1,NI
      COV1=COV(1,I,1)+COV(2,I,1)/AA/AA
      COV2=COV(1,I,2)+COV(2,I,2)*AA*AA
      COV3=COV(1,I,3)+COV(2,I,3)
      DETMIN=COV1*COV2-COV3*COV3
      INV(I,1)=COV2/DETMIN
      INV(I,2)=COV1/DETMIN
      INV(I,3)=-COV3/DETMIN
20    CONTINUE
C*****    COMPUTE BB CORRESPONDING TO THIS VALUE OF AA
      BB=0.
      DENOM=0.
      DO 40 I=1,NI
      BB=BB+INV(I,3)*(A(1,I)-A(2,I)/AA)+INV(I,2)*(B(1,I)-B(2,I)*AA)
      DENOM=DENOM+INV(I,2)
40    CONTINUE
      BB=BB/DENOM
C*****     SUM CHI-SQUARES OVER ALL ITEMS
      Q=0.
      DO 60 I=1,NI
      DIFFA=A(2,I)/AA-A(1,I)
      DIFFB=B(2,I)*AA+BB-B(1,I)
      Q=Q+DIFFA*DIFFA*INV(I,1)+DIFFB*DIFFB*INV(I,2)+2.*DIFFA*DIFFB*
     2  INV(I,3)
60    CONTINUE
      RETURN
      END
C**************************************************************************
      SUBROUTINE ZSCORE(P,Z)
C
C     COMPUTE THE STANDARD SCORE GIVEN THE **RIGHT** TAIL PROBABILITY
C     IN A STANDARD NORMAL DISTRIBUTION.  THIS IS A MODIFICATION OF
C     ALGORITHM AS 70 BY ODEH EVANS, APPL STATIST VOL. 23, P. 97.
C     REQUIRED BUILT-IN FUNCTION IS ALOG FOR NATURAL LOGARITHM
C
      REAL*8 Y,PS
      DATA P0,P1,P2,P3,P4/-.3222324,-1.0,-.3422421,-.2042312E-1,
     2 -.4536422E-4/
      DATA Q0,Q1,Q2,Q3,Q4/.9934846E-1,.5885816,.5311035,.1035378,
     2 .3856070E-2/
      PS=P
      IF(P.GT..5) PS=1.0-P
      Y=DSQRT(-DLOG(PS*PS))
      Z=Y+((((P4*Y+P3)*Y+P2)*Y+P1)*Y+P0)/((((Q4*Y+Q3)*Y+Q2)*Y+Q1)
     2 *Y+Q0)
      IF(P.GT..5) Z=-Z
C                 P IS THE PROBABILITY BEYOND Z
      RETURN
      END
