      SUBROUTINE  LINMIN(P, XI, N, FRET)
C ROUTINE FROM NUMERICAL RECIPES PAGE 300
C DOES LINE MINIMIZATION
C P IS N DIMENSIONAL POINT (OUTPUT)
C XI IS DIRECTION TO MOVE TOWARDS P
C FRET IS VALUE OF FUNCTION AT POINT P (OUTPUT)
CALLS F1DIM,MNBRAK
      PARAMETER (NMAX=2, TOL=1.E-4)
      EXTERNAL F1DIM
      DIMENSION P(N), XI(N)
      COMMON /F1COM/ NCOM, PCOM(NMAX), XICOM(NMAX)
C      WRITE(*,6200) P(1),P(2),XI(1),XI(2),N
C 6200 FORMAT(' 6200  ENTER LINMIN WITH  ',4F12.6,I4)
      NCOM=N
      DO 11 J=1,N
          PCOM(J)=P(J)
          XICOM(J)=XI(J)
  11       CONTINUE
      AX=0.
      XX=1.
      BX=2.
      CALL MNBRAK(AX, XX, BX, FA, FX, FB, F1DIM)
      FRET=BRENT(AX, XX, BX, F1DIM, TOL, XMIN)
      DO 12 J=1,N
          XI(J)=XMIN*XI(J)
          P(J)=P(J)+XI(J)
  12       CONTINUE
C      WRITE(*,6210) XI(1),XI(2),P(1),P(2)
C 6210 FORMAT(' 6210 EXIT LINMIN WITH ',4F12.6)
      RETURN
      END
