      SUBROUTINE MNBRAK(AX, BX, CX, FA, FB, FC, FUNCX)
C ROUTINE FROM NUMERICAL RECIPES PAGE 281
C IT BRACKETS THE MINIMUM OF A FUNCTION CALLED FUNCX
C AX,BX,CX ARE BRACKETING TRIPLET, AX,BX ARE INITIAL VALUES
C FA,FB,FC ARE THE RETURNED VALUES OF THE FUNCTION AT AX,BX,CX
C USES F1DIM AS FUNCX
      PARAMETER (GOLD=1.618034, GLIMIT=100., TINY=1.E-20)
C      WRITE(*,6300) AX,BX,CX
C 6300 FORMAT(' 6300  ENTER MNBRAK WITH  ',3F10.6)
      FA=FUNCX(AX)
      FB=FUNCX(BX)
      IF(FB.GT.FA)THEN 
          DUM=AX 
          AX=BX 
          BX=DUM 
          DUM=FB 
          FB=FA 
          FA=DUM 
      ENDIF 
      CX=BX+GOLD*(BX-AX) 
      FC=FUNCX(CX)
   1  IF(FB.GE.FC)THEN 
          R=(BX-AX)*(FB-FC) 
          Q=(BX-CX)*(FB-FA) 
          U=BX-((BX-CX)*Q-(BX-AX)*R)/(2.*SIGN(MAX(ABS(Q-R),TINY),Q-R)) 
          ULIM=BX+GLIMIT*(CX-BX) 
          IF((BX-U)*(U-CX).GT.0.)THEN 
	      FU=FUNCX(U)
              IF(FU.LT.FC)THEN 
                  AX=BX 
                  FA=FB 
                  BX=U 
                  FB=FU 
                  GO TO 1 
               ELSE IF(FU.GT.FB)THEN 
                  CX=U 
                  FC=FU 
                  GO TO 1 
               ENDIF 
               U=CX+GOLD*(CX-BX) 
	       FU=FUNCX(U)
          ELSE IF((CX-U)*(U-ULIM).GT.0.)THEN 
	       FU=FUNCX(U)
               IF(FU.LT.FC)THEN 
                   BX=CX 
                   CX=U 
                   U=CX+GOLD*(CX-BX) 
                   FB=FC 
                   FC=FU 
		   FU=FUNCX(U)
               ENDIF 
          ELSE  IF((U-ULIM)*(ULIM-CX).GE.0.)THEN 
              U=ULIM 
	      FU=FUNCX(U)
          ELSE 
              U=CX+GOLD*(CX-BX) 
	      FU=FUNCX(U)
          ENDIF 
          AX=BX 
          BX=CX 
          CX=U 
          FA=FB 
          FB=FC 
          FC=FU 
          GO TO 1 
      ENDIF
C      WRITE(*,6310) FA,FB,FC
C 6310 FORMAT('6310 EXIT MNBRAK WITH ',3F12.6)
      RETURN 
      END 
    
